import socket


class PyNovTcp():

    def __init__(self, addr):
        self.isConnected = False
        self.sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        self.server_address = (addr, 5025)

    def open(self):
        self.sock.connect(self.server_address)
        self.isConnected = True

    def read(self, addr):
        # Send data
        my_bytes = bytearray()
        my_bytes.append(82)
        my_bytes.append(addr >> 8)
        my_bytes.append(addr & 0xFF)
    
        # print("send")
        self.sock.send(my_bytes)

        # Receive the response
        # print("receive")
        data = self.sock.recv(2)

        return data[0]*256 + data[1]


    def write(self, addr, data):
        # Send data
        my_bytes = bytearray()
        my_bytes.append(87)
        my_bytes.append(addr >> 8)
        my_bytes.append(addr & 0xFF)
        my_bytes.append(data >> 8)
        my_bytes.append(data & 0xFF)

        #print("send")
        self.sock.send(my_bytes)

    def close(self):
        self.sock.close()
        self.isConnected = False
